# simple-git-hooks


 ![](https://img.shields.io/badge/dependencies-zero-green) [![Tests](https://github.com/toplenboren/simple-git-hooks/actions/workflows/tests.yml/badge.svg?branch=master)](https://github.com/toplenboren/simple-git-hooks/actions/workflows/tests.yml)

A tool that lets you easily manage git hooks

> The package was recently renamed from `simple-pre-commit`. See **Releases** for the `simple-pre-commit` documentation.

## Usage

### Add simple-git-hooks to the project

1. Install simple-git-hooks as a dev dependency:
   
   ```sh
   npm install simple-git-hooks --save-dev
   ```

2. Add `simple-git-hooks` to your `package.json`. Fill it with git hooks and the corresponding commands.

    For example:

    ```jsonc
    {
      "simple-git-hooks": {
        "pre-commit": "npx lint-staged",
        "pre-push": "cd ../../ && npm run format",

        // All unused hooks will be removed automatically by default
        // but you can use the `preserveUnused` option like following to prevent this behavior

        // if you'd prefer preserve all unused hooks
        "preserveUnused": true,

        // if you'd prefer preserve specific unused hooks
        "preserveUnused": ["commit-msg"]
      }
    }
    ```

    This configuration is going to run all linters on every `commit` and formatter on `push`.
    
   > There are more ways to configure the package. Check out [Additional configuration options](#additional-configuration-options).
    
3. Run the CLI script to update the git hooks with the commands from the config:

   ```sh
   npx simple-git-hooks
   ```
    
Now all the git hooks are created.

### Update git hooks command

1. Change the configuration.

2. Run `npx simple-git-hooks` **from the root of your project**.

Note for **yarn2** users: Please run `yarn dlx simple-git-hooks` instead of the command above. More info on [dlx](https://yarnpkg.com/cli/dlx)

Note that you should manually run `npx simple-git-hooks` **every time you change a command**.
